/*
 * _gen/svc-Connection_Interface_Presence.h - Header for TpSvcConnectionInterfacePresence
 *
 * 
    Copyright (C) 2005, 2006 Collabora Limited
  
 * 
Copyright (C) 2005, 2006 Nokia Corporation
  
 * 
Copyright (C) 2006 INdT
  
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#ifndef __TP_SVC_CONNECTION_INTERFACE_PRESENCE_H__
#define __TP_SVC_CONNECTION_INTERFACE_PRESENCE_H__

#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * TpSvcConnectionInterfacePresence:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _TpSvcConnectionInterfacePresence TpSvcConnectionInterfacePresence;

/**
 * TpSvcConnectionInterfacePresenceClass:
 *
 * The class of TpSvcConnectionInterfacePresence.
 */
typedef struct _TpSvcConnectionInterfacePresenceClass TpSvcConnectionInterfacePresenceClass;


GType tp_svc_connection_interface_presence_get_type (void);

/* TYPE MACROS */
#define TP_TYPE_SVC_CONNECTION_INTERFACE_PRESENCE \
  (tp_svc_connection_interface_presence_get_type ())
#define TP_SVC_CONNECTION_INTERFACE_PRESENCE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), TP_TYPE_SVC_CONNECTION_INTERFACE_PRESENCE, TpSvcConnectionInterfacePresence))
#define TP_IS_SVC_CONNECTION_INTERFACE_PRESENCE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), TP_TYPE_SVC_CONNECTION_INTERFACE_PRESENCE))
#define TP_SVC_CONNECTION_INTERFACE_PRESENCE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TP_TYPE_SVC_CONNECTION_INTERFACE_PRESENCE, TpSvcConnectionInterfacePresenceClass))


typedef void (*tp_svc_connection_interface_presence_add_status_impl) (TpSvcConnectionInterfacePresence *self,
                                                                      const gchar *status,
                                                                      GHashTable *parms,
                                                                      DBusGMethodInvocation *context);
void tp_svc_connection_interface_presence_implement_add_status (TpSvcConnectionInterfacePresenceClass *klass, tp_svc_connection_interface_presence_add_status_impl impl);


/**
 * tp_svc_connection_interface_presence_return_from_add_status:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_interface_presence_return_from_add_status (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_connection_interface_presence_return_from_add_status (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_connection_interface_presence_clear_status_impl) (TpSvcConnectionInterfacePresence *self,
                                                                        DBusGMethodInvocation *context);
void tp_svc_connection_interface_presence_implement_clear_status (TpSvcConnectionInterfacePresenceClass *klass, tp_svc_connection_interface_presence_clear_status_impl impl);


/**
 * tp_svc_connection_interface_presence_return_from_clear_status:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_interface_presence_return_from_clear_status (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_connection_interface_presence_return_from_clear_status (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_connection_interface_presence_get_presence_impl) (TpSvcConnectionInterfacePresence *self,
                                                                        const GArray *contacts,
                                                                        DBusGMethodInvocation *context);
void tp_svc_connection_interface_presence_implement_get_presence (TpSvcConnectionInterfacePresenceClass *klass, tp_svc_connection_interface_presence_get_presence_impl impl);


/**
 * tp_svc_connection_interface_presence_return_from_get_presence:
 * @dbus_context: The D-Bus method invocation context
 * @presence: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_interface_presence_return_from_get_presence (DBusGMethodInvocation *dbus_context,
                                                               GHashTable *presence)
;
static inline void
tp_svc_connection_interface_presence_return_from_get_presence (DBusGMethodInvocation *dbus_context,
                                                               GHashTable *presence)
{
  dbus_g_method_return (dbus_context, presence);
}
typedef void (*tp_svc_connection_interface_presence_get_statuses_impl) (TpSvcConnectionInterfacePresence *self,
                                                                        DBusGMethodInvocation *context);
void tp_svc_connection_interface_presence_implement_get_statuses (TpSvcConnectionInterfacePresenceClass *klass, tp_svc_connection_interface_presence_get_statuses_impl impl);


/**
 * tp_svc_connection_interface_presence_return_from_get_statuses:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_interface_presence_return_from_get_statuses (DBusGMethodInvocation *dbus_context,
                                                               GHashTable *ret)
;
static inline void
tp_svc_connection_interface_presence_return_from_get_statuses (DBusGMethodInvocation *dbus_context,
                                                               GHashTable *ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_connection_interface_presence_remove_status_impl) (TpSvcConnectionInterfacePresence *self,
                                                                         const gchar *status,
                                                                         DBusGMethodInvocation *context);
void tp_svc_connection_interface_presence_implement_remove_status (TpSvcConnectionInterfacePresenceClass *klass, tp_svc_connection_interface_presence_remove_status_impl impl);


/**
 * tp_svc_connection_interface_presence_return_from_remove_status:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_interface_presence_return_from_remove_status (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_connection_interface_presence_return_from_remove_status (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_connection_interface_presence_request_presence_impl) (TpSvcConnectionInterfacePresence *self,
                                                                            const GArray *contacts,
                                                                            DBusGMethodInvocation *context);
void tp_svc_connection_interface_presence_implement_request_presence (TpSvcConnectionInterfacePresenceClass *klass, tp_svc_connection_interface_presence_request_presence_impl impl);


/**
 * tp_svc_connection_interface_presence_return_from_request_presence:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_interface_presence_return_from_request_presence (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_connection_interface_presence_return_from_request_presence (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_connection_interface_presence_set_last_activity_time_impl) (TpSvcConnectionInterfacePresence *self,
                                                                                  guint time,
                                                                                  DBusGMethodInvocation *context);
void tp_svc_connection_interface_presence_implement_set_last_activity_time (TpSvcConnectionInterfacePresenceClass *klass, tp_svc_connection_interface_presence_set_last_activity_time_impl impl);


/**
 * tp_svc_connection_interface_presence_return_from_set_last_activity_time:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_interface_presence_return_from_set_last_activity_time (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_connection_interface_presence_return_from_set_last_activity_time (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_connection_interface_presence_set_status_impl) (TpSvcConnectionInterfacePresence *self,
                                                                      GHashTable *statuses,
                                                                      DBusGMethodInvocation *context);
void tp_svc_connection_interface_presence_implement_set_status (TpSvcConnectionInterfacePresenceClass *klass, tp_svc_connection_interface_presence_set_status_impl impl);


/**
 * tp_svc_connection_interface_presence_return_from_set_status:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_interface_presence_return_from_set_status (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_connection_interface_presence_return_from_set_status (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void tp_svc_connection_interface_presence_emit_presence_update (gpointer instance,
    const GHashTable * presence);



G_END_DECLS

#endif /* #ifndef __TP_SVC_CONNECTION_INTERFACE_PRESENCE_H__*/
