/*
 * _gen/svc-Connection_Interface_Privacy.h - Header for TpSvcConnectionInterfacePrivacy
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#ifndef __TP_SVC_CONNECTION_INTERFACE_PRIVACY_H__
#define __TP_SVC_CONNECTION_INTERFACE_PRIVACY_H__

#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * TpSvcConnectionInterfacePrivacy:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _TpSvcConnectionInterfacePrivacy TpSvcConnectionInterfacePrivacy;

/**
 * TpSvcConnectionInterfacePrivacyClass:
 *
 * The class of TpSvcConnectionInterfacePrivacy.
 */
typedef struct _TpSvcConnectionInterfacePrivacyClass TpSvcConnectionInterfacePrivacyClass;


GType tp_svc_connection_interface_privacy_get_type (void);

/* TYPE MACROS */
#define TP_TYPE_SVC_CONNECTION_INTERFACE_PRIVACY \
  (tp_svc_connection_interface_privacy_get_type ())
#define TP_SVC_CONNECTION_INTERFACE_PRIVACY(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), TP_TYPE_SVC_CONNECTION_INTERFACE_PRIVACY, TpSvcConnectionInterfacePrivacy))
#define TP_IS_SVC_CONNECTION_INTERFACE_PRIVACY(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), TP_TYPE_SVC_CONNECTION_INTERFACE_PRIVACY))
#define TP_SVC_CONNECTION_INTERFACE_PRIVACY_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TP_TYPE_SVC_CONNECTION_INTERFACE_PRIVACY, TpSvcConnectionInterfacePrivacyClass))


typedef void (*tp_svc_connection_interface_privacy_get_privacy_mode_impl) (TpSvcConnectionInterfacePrivacy *self,
                                                                           DBusGMethodInvocation *context);
void tp_svc_connection_interface_privacy_implement_get_privacy_mode (TpSvcConnectionInterfacePrivacyClass *klass, tp_svc_connection_interface_privacy_get_privacy_mode_impl impl);


/**
 * tp_svc_connection_interface_privacy_return_from_get_privacy_mode:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_interface_privacy_return_from_get_privacy_mode (DBusGMethodInvocation *dbus_context,
                                                                  const gchar *ret)
;
static inline void
tp_svc_connection_interface_privacy_return_from_get_privacy_mode (DBusGMethodInvocation *dbus_context,
                                                                  const gchar *ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_connection_interface_privacy_get_privacy_modes_impl) (TpSvcConnectionInterfacePrivacy *self,
                                                                            DBusGMethodInvocation *context);
void tp_svc_connection_interface_privacy_implement_get_privacy_modes (TpSvcConnectionInterfacePrivacyClass *klass, tp_svc_connection_interface_privacy_get_privacy_modes_impl impl);


/**
 * tp_svc_connection_interface_privacy_return_from_get_privacy_modes:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_interface_privacy_return_from_get_privacy_modes (DBusGMethodInvocation *dbus_context,
                                                                   const gchar **ret)
;
static inline void
tp_svc_connection_interface_privacy_return_from_get_privacy_modes (DBusGMethodInvocation *dbus_context,
                                                                   const gchar **ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_connection_interface_privacy_set_privacy_mode_impl) (TpSvcConnectionInterfacePrivacy *self,
                                                                           const gchar *mode,
                                                                           DBusGMethodInvocation *context);
void tp_svc_connection_interface_privacy_implement_set_privacy_mode (TpSvcConnectionInterfacePrivacyClass *klass, tp_svc_connection_interface_privacy_set_privacy_mode_impl impl);


/**
 * tp_svc_connection_interface_privacy_return_from_set_privacy_mode:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_interface_privacy_return_from_set_privacy_mode (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_connection_interface_privacy_return_from_set_privacy_mode (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void tp_svc_connection_interface_privacy_emit_privacy_mode_changed (gpointer instance,
    const gchar * mode);



G_END_DECLS

#endif /* #ifndef __TP_SVC_CONNECTION_INTERFACE_PRIVACY_H__*/
