/* Generated from the Telepathy spec, version 0.15.4

Copyright (C) 2005, 2006, 2007 Collabora Limited
Copyright (C) 2005, 2006, 2007 Nokia Corporation
Copyright (C) 2006 INdT

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.


*/

#ifdef __cplusplus
extern "C" {
#endif


/**
 * TpChannelContactSearchState:
 * @TP_CHANNEL_CONTACT_SEARCH_STATE_BEFORE: <![CDATA[The search has not started]]>
 * @TP_CHANNEL_CONTACT_SEARCH_STATE_DURING: <![CDATA[The search is in progress]]>
 * @TP_CHANNEL_CONTACT_SEARCH_STATE_AFTER: <![CDATA[The search has been completed]]>
 *
 * Enumeration generated from the Telepathy specification.
 */
typedef enum {
    TP_CHANNEL_CONTACT_SEARCH_STATE_BEFORE = 0,
    TP_CHANNEL_CONTACT_SEARCH_STATE_DURING = 1,
    TP_CHANNEL_CONTACT_SEARCH_STATE_AFTER = 2,
} TpChannelContactSearchState;

/**
 * NUM_TP_CHANNEL_CONTACT_SEARCH_STATES:
 *
 * 1 higher than the highest valid value of #TpChannelContactSearchState.
 */
#define NUM_TP_CHANNEL_CONTACT_SEARCH_STATES (2+1)


/**
 * TpTubeType:
 * @TP_TUBE_TYPE_DBUS: <![CDATA[           An ordered reliable transport, for transporting D-Bus traffic.            For each D-Bus tube, the connection manager listens on a D-Bus           server address, as detailed in the D-Bus specification. On this           address, it emulates a bus upon which each tube participant appears           as an endpoint. The service name of a D-Bus tube should be a           well-known D-Bus service name, of the form com.example.ServiceName.            The objects and interfaces which are expected to exist on the           emulated bus depend on the well-known name; typically, either the           participant who initiated the tube is expected to export the same           objects/interfaces that would be exported by a service of that name           on a bus, or all participants are expected to export those           objects/interfaces.         ]]>
 *
 * Enumeration generated from the Telepathy specification.
 */
typedef enum {
    TP_TUBE_TYPE_DBUS = 0,
} TpTubeType;

/**
 * NUM_TP_TUBE_TYPES:
 *
 * 1 higher than the highest valid value of #TpTubeType.
 */
#define NUM_TP_TUBE_TYPES (0+1)


/**
 * TpTubeState:
 * @TP_TUBE_STATE_LOCAL_PENDING: <![CDATA[           The tube is waiting to be accepted/closed locally.         ]]>
 * @TP_TUBE_STATE_REMOTE_PENDING: <![CDATA[           The tube is waiting to be accepted/closed remotely.         ]]>
 * @TP_TUBE_STATE_OPEN: <![CDATA[           The tube is open for traffic.         ]]>
 *
 * Enumeration generated from the Telepathy specification.
 */
typedef enum {
    TP_TUBE_STATE_LOCAL_PENDING = 0,
    TP_TUBE_STATE_REMOTE_PENDING = 1,
    TP_TUBE_STATE_OPEN = 2,
} TpTubeState;

/**
 * NUM_TP_TUBE_STATES:
 *
 * 1 higher than the highest valid value of #TpTubeState.
 */
#define NUM_TP_TUBE_STATES (2+1)


/**
 * TpChannelHoldState:
 * @TP_CHANNEL_HOLD_STATE_NONE: <![CDATA[             Neither the local user and the remote member are on hold, and media             is being sent bidirectionally.       ]]>
 * @TP_CHANNEL_HOLD_STATE_SEND_ONLY: <![CDATA[             The local user has put the remote member on hold, so is sending             media but has arranged not to receive any media streams.       ]]>
 * @TP_CHANNEL_HOLD_STATE_RECV_ONLY: <![CDATA[             The user has been put on hold by the remote member, so is receiving             media but has arranged not to send any media streams.       ]]>
 * @TP_CHANNEL_HOLD_STATE_BOTH: <![CDATA[             Both the local user and the remote member have agreed not to send             any media streams to each other.       ]]>
 *
 * Enumeration generated from the Telepathy specification.
 */
typedef enum {
    TP_CHANNEL_HOLD_STATE_NONE = 0,
    TP_CHANNEL_HOLD_STATE_SEND_ONLY = 1,
    TP_CHANNEL_HOLD_STATE_RECV_ONLY = 2,
    TP_CHANNEL_HOLD_STATE_BOTH = 3,
} TpChannelHoldState;

/**
 * NUM_TP_CHANNEL_HOLD_STATES:
 *
 * 1 higher than the highest valid value of #TpChannelHoldState.
 */
#define NUM_TP_CHANNEL_HOLD_STATES (3+1)



#ifdef __cplusplus
}
#endif

